	TITLE Hoot Wood Sim
*******************************************************
* APLET VIDE 1.0							*
* by Jean-Yves Avenard						*
* Translation by Michal De Coninck				*
* optimizing by Noda						*
* If you want to compile it do the following things:	*
* >rplcomp Aplet.s Aplet.c					*
* >sasm -B -W -a Aplet.l -o Aplet.o Aplet.c		*
* >sload -H Aplet.m						*
*******************************************************

INCLUDE =Entry39.h
INCLUDE =Common.h
INCLUDE =Command.h
ASSEMBLE

*************************************************
*		     Name of the Aplet			*
*************************************************

	Dir_Head 14,Hoot Woods Sim,601
*              ^1    ^2       ^3
* ^1=Lenght of the name of the aplet.
* ^2=Name of the aplet.
* ^3=Number of the library. This is necessary even if the library is empty. 

RPL
     StndtType			( This aplet skeleton will only provide access to the "C" type of aplet )
INCLUDE =Sharedvar.h
ASSEMBLE 
	Vfield  L34,IntTable
	CON(5)	=DOHSTR
	REL(5)  endLink
	Link	_Main	
	Link	_Entry
	Link	_Exit
	Link	_Action		( Include all the variables needed by the aplet structure )
	Link	_DispText

* Put here your self-made label. Don't forget to DEFINE AND INT_xx them beneath.  

endLink
RPL
DEFINE Main		INT_00
DEFINE Entry	INT_01
DEFINE Exit		INT_02
DEFINE Action	INT_03
DEFINE DispText	INT_04

ASSEMBLE
	Vfield  IntTable,DirVar
RPL
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)  endCode
RPL

* The HP39/40G provides a list of 91 TopicVariables that can contain any kind of object
* Instead of using local variables as on the HP48/49, it's a good idea to use these
* variables instead. The access is really fast and easy. The contain of these variables
* will be preserved while the aplet is running. If you're exiting the view or
* switch to another aplet, the content will be deleted.
* To ease the access to your variables, use alias like:

DEFINE  Survived! TopicVar5!
DEFINE  Survived@ TopicVar5@
DEFINE  Pix_Y! TopicVar4!
DEFINE  Pix_Y@ TopicVar4@
DEFINE  Pix_X! TopicVar3!
DEFINE  Pix_X@ TopicVar3@
DEFINE  Owls! TopicVar2!
DEFINE  Owls@ TopicVar2@
DEFINE  Mice! TopicVar1!
DEFINE  Mice@ TopicVar1@

ASSEMBLE
=DISPXYmini	EQU	#3F8A0				( for miniFONT )
=TOD	EQU	#3F755					( Time of Date )
RPL

DEFINE	Save@	LastBut3
DEFINE	Save!	LastBut3 REPLACE DROP

*************************************************
*	         Self-made variables			*
*************************************************
* ici

NAMELESS _Main
  ::
     StndCheck
     ' Entry
     ' Exit
     '
	::
	EnsureMenuOff
	;
     '
	::
	  {
	   { kcSymbView :: TakeOver Action ;	( Enter or Symb to continue the program )
	     kcEnter :: TakeOver Action ;
	   }
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
	   NULL{}
          }
          ONE KeyFace
       ;
    TRUE
   {
   {
	::
	;
    }
    }
    ONE
    '
    ::	TURNMENUON RECLAIMDISP
	ERRJMP
    ;
  ;
NAMELESS _Entry
::
*************************************************
*		Begin of the presentation		*
*************************************************

 TURNMENUOFF
 HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP

 $ "  ~Hoot Woods Sim~"
  DISPROW1
 $ "  Michal De Coninck"
  DISPROW3
 $ "ndco232@tiscalinet.be" 
  DISPROW5
 $ " Press Enter to start"
  DISPROW8

**************************************************
*		  End of the presentation		 *
**************************************************
;

NAMELESS _Action
::
*************************************************
*		      Begin of the program		*
*************************************************

 HARDBUFF ZEROZERO BINT_131d SIXTYFOUR GROB!ZERODRP	( clears screen )

 TOD %RANDOMIZE							( to have real random numbers ) 

 ZERO FIFTY FIFTY FIFTY LINEON				( Draw some lines on the screen )
 FIFTY ZERO OVER FIFTY LINEON
 THREE Mice!							( We start with 3 mice )
 ONE Owls! 								( and one owl )

 BEGIN

 HARDBUFF ZEROZERO  BINT50 BINT50 GROB!ZERODRP		( clear area )
 HARDBUFF BINT52 ZERO BINT_131d BINT30 GROB!ZERODRP	( clear text )
 HARDBUFF ZERO BINT55 BINT_131d SIXTYFOUR GROB!ZERODRP ( clear text 2 )

 Owls@ ZERO EQIT :: ONE Owls! ;
 Mice@ THREE #< IT :: THREE Mice! ;
 Mice@ # 9C4 #> IT :: # 9C4 Mice! ;				( Mice > 2500 )
 
 BINT52 ONE
 "Mice: " Mice@ UNCOERCE DO>STR &$				( Mice is a BINT )
 DispText

 BINT52 EIGHT 
 "Owls: " Owls@ UNCOERCE DO>STR &$				( Owls too! )
 DispText

 Mice@ #1+_ONE_DO (DO)
 
  BEGIN
   %RAN % 50 %* %IP COERCE Pix_X!
   %RAN % 50 %* %IP COERCE Pix_Y!
   Pix_X@ Pix_Y@ PIXON? FALSE EQ
  UNTIL

  Pix_X@ Pix_Y@ PIXON

  BINT52 BINT15
   INDEX@ UNCOERCE DO>STR " / " &$ Mice@ UNCOERCE DO>STR &$
  DispText

 LOOP									( end of Mice Loop )

 Owls@ #1+_ONE_DO (DO)
  
 BINT52 BINT22
  INDEX@ UNCOERCE DO>STR " / " &$ Owls@ UNCOERCE DO>STR &$
 DispText

 ZERO Survived!

 %RAN % 44 %* %IP COERCE Pix_X!
 %RAN % 44 %* %IP COERCE Pix_Y!

 Pix_X@ #5+ #1+ Pix_X@ 
  DO
   Pix_Y@ #5+ #1+ Pix_Y@
    DO
     JINDEX@ INDEX@ PIXON? TRUE EQITE ONE ZERO DUP Mice@ SWAP #- Mice!
     Survived@ #+ Survived!
     JINDEX@ INDEX@ PIXOFF
    LOOP
  LOOP

 Survived@ UNCOERCE %3 %/ %IP COERCE Survived!
 Survived@ ZERO EQITE ONE ZERO Owls@ SWAP #- Owls!

 LOOP									( end of owls loop )	
						
 Owls@ Survived@ #+ Owls!
 TWO Mice@ #* Mice!

 SEVEN BINT55
 "ENTER to continue, ON to stop"
 DispText

 WaitForKey DROP DUP  
 
 kcOn EQ
 UNTIL

 Entry
 
**************************************************
*		       End of the program		*
**************************************************
;


NAMELESS _DispText
::
 HARDBUFF					( show the text on hardbuff ) 
 FOUR ROLL FOUR ROLL			( take X and Y coordinate )
 FOUR ROLL DUPLEN$ 			( take the string, duplicate and give length )
 FOUR #* 					( length * 4 )
 DISPXYmini					( Display it in miniFont *unsupported entry* )
 DROP						( drop ) 
;						( end of DispText )

NAMELESS _Exit
  ::
   LeaveGraphView
  ;
ASSEMBLE
endCode
RPL
ASSEMBLE
	Vfield DirVar,DirCode

* This variable will contain all the saved parameters of the aplet
* You can add your own variable in the list

RPL
  {
  ONE		( Add your default parameters here for the variable 'save' )
  TWO
  }
ASSEMBLE
	Vfield DirCode,DirAlt
RPL
  { }
ASSEMBLE
	Vfield DirAlt,DirNot
RPL

**************************************************
*		     Note of the aplet			 *
**************************************************
* if you want to put text in a note do it here   *
* beneath, between the " "				 *
**************************************************

$ "This is a hoot woods simulator. Read the readme for more information about this program.\nPorted from the TI-83 version."

ASSEMBLE
	Vfield DirNot,DirEnd
RPL
  { }
